unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, XMLObject,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    BtnSaveToFile1: TButton;
    BtnCreateXMLObject1: TButton;
    Panel2: TPanel;
    Label2: TLabel;
    BtnSaveToFile2: TButton;
    BtnCreateXMLObject2: TButton;
    Panel3: TPanel;
    Label3: TLabel;
    BtnSaveToFile3: TButton;
    BtnCreateXMLObject3: TButton;
    BtnXML: TButton;
    Button1: TButton;
    procedure BtnSaveToFile1Click(Sender: TObject);
    procedure BtnCreateXMLObject1Click(Sender: TObject);
    procedure BtnSaveToFile2Click(Sender: TObject);
    procedure BtnCreateXMLObject2Click(Sender: TObject);
    procedure BtnSaveToFile3Click(Sender: TObject);
    procedure BtnCreateXMLObject3Click(Sender: TObject);
    procedure BtnXMLClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  TXMLObject1 = class(TXMLObject)
  private
    FPropString1, FPropString2: string;
    FPropInteger: Integer;
    FPropFloat: Double;
  published
    property PropString1: string read FPropString1 write FPropString1;
    property PropString2: string read FPropString2 write FPropString2;
    property PropInteger: Integer read FPropInteger write FPropInteger;
    property PropFloat: Double read FPropFloat write FPropFloat;
  end;

  TXMLObject2 = class(TXMLObject)
  private
    FPropString: string;
    FXMLObject1: TXMLObject1;
  published
    property PropString: string read FPropString write FPropString;
    property XMLObject1: TXMLObject1 read FXMLObject1 write FXMLObject1;
  end;

  TXMLObject3 = class(TXMLObject)
  private
    FCollection: TCollection;
  published
    property Collection: TCollection read FCollection write FCollection;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BtnSaveToFile1Click(Sender: TObject);
var
  XMLObject1: TXMLObject1;
begin
  XMLObject1 := TXMLObject1.Create(nil);
  with XMLObject1 do
  begin
    PropString1 := 'Hello';
    PropString2 := 'World !';
    PropInteger := 123;
    PropFloat := 1.23;
    try
      SaveToFile('XMLObject1.txt');
    finally
      Free;
    end;
  end;
end;

procedure TForm1.BtnCreateXMLObject1Click(Sender: TObject);
var
  XMLObject1: TXMLObject1;
begin
  XMLObject1 := CreateXMLObjFromFile('XMLObject1.txt') as TXMLObject1;
  with XMLObject1 do
  begin
    ShowMessage(Format('PropString1 : "%s"'#13'PropString2 : "%s"'#13'PropInteger : "%d"'#13'PropFloat : "%f"',
      [PropString1, PropString2, PropInteger, PropFloat]));
    Free;
  end;
end;

procedure TForm1.BtnSaveToFile2Click(Sender: TObject);
var
  XMLObject1: TXMLObject1;
  XMLObject2: TXMLObject2;
begin
  XMLObject1 := TXMLObject1.Create(nil);
  XMLObject1.PropString1 := 'Hello';
  XMLObject1.PropString2 := 'World !';

  XMLObject2 := TXMLObject2.Create(nil);
  XMLObject2.PropString := 'XMLObject2';
  XMLObject2.XMLObject1 := XMLObject1;
  try
    XMLObject2.SaveToFile('XMLObject2.txt');
  finally
    XMLObject1.Free;
    XMLObject2.Free;
  end;
end;

procedure TForm1.BtnCreateXMLObject2Click(Sender: TObject);
var
  XMLObject2: TXMLObject2;
begin
  XMLObject2 := CreateXMLObjFromFile('XMLObject2.txt') as TXMLObject2;
  ShowMessage(Format('PropString : %s'#13'XMLObject1.PropString1 : "%s"'#13'XMLObject1.PropString2 : "%s"',
    [XMLObject2.PropString, XMLObject2.XMLObject1.PropString1, XMLObject2.XMLObject1.PropString2]));
  XMLObject2.Free;
end;

procedure TForm1.BtnSaveToFile3Click(Sender: TObject);
var
  XMLObject3: TXMLObject3;
begin
  XMLObject3 := TXMLObject3.Create(nil);
  XMLObject3.Collection := TCollection.Create(TXMLObject1);
  with TXMLObject1.Create(XMLObject3.Collection) do
    PropString1 := 'Item 0';
  with TXMLObject1.Create(XMLObject3.Collection) do
    PropString1 := 'Item 1';
  with TXMLObject1.Create(XMLObject3.Collection) do
    PropString1 := 'Item 2';

  try
    XMLObject3.SaveToFile('XMLObject3.txt');
  finally
    XMLObject3.Collection.Free;
    XMLObject3.Free;
  end;
end;

procedure TForm1.BtnCreateXMLObject3Click(Sender: TObject);
var
  XMLObject3: TXMLObject3;
  I: Integer;
  Msg: string;
begin
  XMLObject3 := CreateXMLObjFromFile('XMLObject3.txt') as TXMLObject3;

  for I := 0 to XMLObject3.Collection.Count-1 do
    with XMLObject3.Collection.Items[I] as TXMLObject1 do
      Msg := Msg + Format('Item : %d, PropString1 : "%s"', [I, PropString1]) + #13;

  ShowMessage(Msg);
  XMLObject3.Free;
end;

procedure TForm1.BtnXMLClick(Sender: TObject);
var
  XMLObject1: TXMLObject1;
begin
  XMLObject1 := TXMLObject1.Create(nil);
  with XMLObject1 do
  begin
    PropString1 := 'Hello';
    PropString2 := 'World !';
    PropInteger := 123;
    PropFloat := 1.23;
    try
      ShowMessage(xml);
    finally
      Free;
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  XML: string = '<XMLOBJECT ClassName="TXMLObject1"><PropString1>Hello</PropString1><PropString2>World !</PropString2></XMLOBJECT>';
var
  XMLObject1: TXMLObject1;
begin
  XMLObject1 := CreateXMLObjFromString(XML) as TXMLObject1;
  ShowMessage(Format('PropString1 : "%s"'#13'PropString2 : "%s"', [XMLObject1.PropString1, XMLObject1.PropString2]));
  XMLObject1.Free;
end;

initialization
  RegisterClasses([TXMLObject1, TXMLObject2, TXMLObject3]);

end.
